clearvars;
clc;

Sim.Ts               = 2e-6;

% Parameters of VSC 1 
% Three Phase Source parameters
VSC1.source.nominal.v        = 420e3;   % 420e3
VSC1.source.nominal.theta    = 0;
VSC1.source.nominal.f        = 60;
VSC1.source.nominal.r        = 4.59;
VSC1.source.nominal.l        = 26.04/(2*pi*VSC1.source.nominal.f);
VSC1.source.basevoltage      = VSC1.source.nominal.v;

VSC3.source.nominal.v        = 500e3;   % 500e3
VSC2.source.nominal.f        = 50;
VSC2.source.nominal.l        = 26.04/(2*pi*VSC2.source.nominal.f);
VSC3.source.basevoltage      = VSC3.source.nominal.v;

% Transformer Source parameters
VSC1.Trf.nominal.MVA         = 1500e6;
VSC1.Trf.nominal.f           = VSC1.source.nominal.f;
VSC1.Trf.nominal.HV          = VSC1.source.nominal.v;
VSC1.Trf.nominal.LV          = 230e3;  
VSC1.Trf.uk                  = 0.1*0.5;
VSC1.Trf.ur                  = 0*0.5;
% VSC1.Trf.MagRm               = 1/0.004; 
% VSC1.Trf.MagXm               = 1/(sqrt((1/(1/0.004))^2-(1/VSC1.Trf.nominal.MVA/(150e6/1e3))^2));

VSC2.Trf.nominal.f           = VSC2.source.nominal.f;
VSC3.Trf.nominal.HV          = VSC3.source.nominal.v;


VSC1.Trf.MagRm               = 1e10; 
VSC1.Trf.MagXm               = 1e10;

% Fault parameters
VSC1.flt.On                 = 99;    % 1.5 default
VSC1.flt.Off                = 999;   % 1.65 default

VSC2.flt.On                 = 99;
VSC2.flt.Off                = 999;

VSC3.flt.On                 = 1.5;
VSC3.flt.Off                = 1.65;

Tstop                       = 2.5;       % Simulation time 5 for step, 2.5 for fault
VSC1.flt.OnR                = 5;
VSC1.flt.GroundR            = 1e-9;

% AC Filter parameters
VSC1.Filter.Lf              = 33.8/1000;
VSC1.Filter.Rf              = 7.6;
VSC1.Filter.Cf              = 3.7e-6;
VSC1.SeriesFilter.Lf        = 72.4/1000;   %72.4 

% VSC1 Parameter
VSC1.Capacitor              = 300e-6;

% Line data 
VSC123.Rline                = 7;
VSC123.Lline                = 0.596;
VSC123.Cline                = 26e-6;

% Control Parameters
VSC1.Ctrl.PLL.PI.Kp         = 10;
VSC1.Ctrl.PLL.PI.Ti         = 1/0.02;
VSC1.Ctrl.fs                = 1980;
VSC1.Ctrl.Omeganom          = 2*pi*VSC1.source.nominal.f;
VSC2.Ctrl.Omeganom          = 2*pi*VSC2.source.nominal.f;
VSC1.Ctrl.DC.Kp             = 0.05;
VSC1.Ctrl.DC.Ti             = 1/1.1;
VSC2.Ctrl.DC.Ti             = 1/0.5;
VSC1.Ctrl.Current.Kp        = 60;
VSC1.Ctrl.Current.Ti        = 1/2e-4;
VSC1.Ctrl.AC.Kp             = 2;
VSC1.Ctrl.AC.Ti             = 1/0.0012;
VSC2.Ctrl.AC.Ti             = 1/0.005;
VSC3.Ctrl.AC.Ti             = 1/0.005;
VSC1.Ctrl.Pref              = 0;
VSC2.Ctrl.Pref              = 200;
VSC3.Ctrl.Pref              = -200;
VSC1.Ctrl.UDCRef_Const      = 400;
VSC1.Ctrl.Deltaomegamin     = -100;
VSC1.Ctrl.Deltaomegamax     = 100;
VSC1.Ctrl.Umin              = -187;
VSC1.Ctrl.Umax              = 187;
VSC1.Ctrl.Idmin             = -4;
VSC1.Ctrl.Idmax             =  4;
VSC1.Ctrl.Iqmin             = -3;
VSC1.Ctrl.Iqmax             =  3;
kw                          = 5;

%  sim('untitled');